package org.eclipse.gef.dot.internal.language.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.gef.dot.internal.language.services.DotPointGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDotPointParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "ExclamationMark", "Comma", "RULE_DOUBLE", "RULE_WS"
    };
    public static final int RULE_WS=7;
    public static final int Comma=5;
    public static final int RULE_DOUBLE=6;
    public static final int EOF=-1;
    public static final int ExclamationMark=4;

    // delegates
    // delegators


        public InternalDotPointParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDotPointParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDotPointParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDotPointParser.g"; }



     	private DotPointGrammarAccess grammarAccess;

        public InternalDotPointParser(TokenStream input, DotPointGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Point";
       	}

       	@Override
       	protected DotPointGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRulePoint"
    // InternalDotPointParser.g:57:1: entryRulePoint returns [EObject current=null] : iv_rulePoint= rulePoint EOF ;
    public final EObject entryRulePoint() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePoint = null;


        try {
            // InternalDotPointParser.g:57:46: (iv_rulePoint= rulePoint EOF )
            // InternalDotPointParser.g:58:2: iv_rulePoint= rulePoint EOF
            {
             newCompositeNode(grammarAccess.getPointRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePoint=rulePoint();

            state._fsp--;

             current =iv_rulePoint; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePoint"


    // $ANTLR start "rulePoint"
    // InternalDotPointParser.g:64:1: rulePoint returns [EObject current=null] : ( ( (lv_x_0_0= RULE_DOUBLE ) ) otherlv_1= Comma ( (lv_y_2_0= RULE_DOUBLE ) ) (otherlv_3= Comma ( (lv_z_4_0= RULE_DOUBLE ) ) )? ( (lv_inputOnly_5_0= ExclamationMark ) )? ) ;
    public final EObject rulePoint() throws RecognitionException {
        EObject current = null;

        Token lv_x_0_0=null;
        Token otherlv_1=null;
        Token lv_y_2_0=null;
        Token otherlv_3=null;
        Token lv_z_4_0=null;
        Token lv_inputOnly_5_0=null;


        	enterRule();

        try {
            // InternalDotPointParser.g:70:2: ( ( ( (lv_x_0_0= RULE_DOUBLE ) ) otherlv_1= Comma ( (lv_y_2_0= RULE_DOUBLE ) ) (otherlv_3= Comma ( (lv_z_4_0= RULE_DOUBLE ) ) )? ( (lv_inputOnly_5_0= ExclamationMark ) )? ) )
            // InternalDotPointParser.g:71:2: ( ( (lv_x_0_0= RULE_DOUBLE ) ) otherlv_1= Comma ( (lv_y_2_0= RULE_DOUBLE ) ) (otherlv_3= Comma ( (lv_z_4_0= RULE_DOUBLE ) ) )? ( (lv_inputOnly_5_0= ExclamationMark ) )? )
            {
            // InternalDotPointParser.g:71:2: ( ( (lv_x_0_0= RULE_DOUBLE ) ) otherlv_1= Comma ( (lv_y_2_0= RULE_DOUBLE ) ) (otherlv_3= Comma ( (lv_z_4_0= RULE_DOUBLE ) ) )? ( (lv_inputOnly_5_0= ExclamationMark ) )? )
            // InternalDotPointParser.g:72:3: ( (lv_x_0_0= RULE_DOUBLE ) ) otherlv_1= Comma ( (lv_y_2_0= RULE_DOUBLE ) ) (otherlv_3= Comma ( (lv_z_4_0= RULE_DOUBLE ) ) )? ( (lv_inputOnly_5_0= ExclamationMark ) )?
            {
            // InternalDotPointParser.g:72:3: ( (lv_x_0_0= RULE_DOUBLE ) )
            // InternalDotPointParser.g:73:4: (lv_x_0_0= RULE_DOUBLE )
            {
            // InternalDotPointParser.g:73:4: (lv_x_0_0= RULE_DOUBLE )
            // InternalDotPointParser.g:74:5: lv_x_0_0= RULE_DOUBLE
            {
            lv_x_0_0=(Token)match(input,RULE_DOUBLE,FOLLOW_3); 

            					newLeafNode(lv_x_0_0, grammarAccess.getPointAccess().getXDOUBLETerminalRuleCall_0_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPointRule());
            					}
            					setWithLastConsumed(
            						current,
            						"x",
            						lv_x_0_0,
            						"org.eclipse.gef.dot.internal.language.DotPoint.DOUBLE");
            				

            }


            }

            otherlv_1=(Token)match(input,Comma,FOLLOW_4); 

            			newLeafNode(otherlv_1, grammarAccess.getPointAccess().getCommaKeyword_1());
            		
            // InternalDotPointParser.g:94:3: ( (lv_y_2_0= RULE_DOUBLE ) )
            // InternalDotPointParser.g:95:4: (lv_y_2_0= RULE_DOUBLE )
            {
            // InternalDotPointParser.g:95:4: (lv_y_2_0= RULE_DOUBLE )
            // InternalDotPointParser.g:96:5: lv_y_2_0= RULE_DOUBLE
            {
            lv_y_2_0=(Token)match(input,RULE_DOUBLE,FOLLOW_5); 

            					newLeafNode(lv_y_2_0, grammarAccess.getPointAccess().getYDOUBLETerminalRuleCall_2_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPointRule());
            					}
            					setWithLastConsumed(
            						current,
            						"y",
            						lv_y_2_0,
            						"org.eclipse.gef.dot.internal.language.DotPoint.DOUBLE");
            				

            }


            }

            // InternalDotPointParser.g:112:3: (otherlv_3= Comma ( (lv_z_4_0= RULE_DOUBLE ) ) )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==Comma) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalDotPointParser.g:113:4: otherlv_3= Comma ( (lv_z_4_0= RULE_DOUBLE ) )
                    {
                    otherlv_3=(Token)match(input,Comma,FOLLOW_4); 

                    				newLeafNode(otherlv_3, grammarAccess.getPointAccess().getCommaKeyword_3_0());
                    			
                    // InternalDotPointParser.g:117:4: ( (lv_z_4_0= RULE_DOUBLE ) )
                    // InternalDotPointParser.g:118:5: (lv_z_4_0= RULE_DOUBLE )
                    {
                    // InternalDotPointParser.g:118:5: (lv_z_4_0= RULE_DOUBLE )
                    // InternalDotPointParser.g:119:6: lv_z_4_0= RULE_DOUBLE
                    {
                    lv_z_4_0=(Token)match(input,RULE_DOUBLE,FOLLOW_6); 

                    						newLeafNode(lv_z_4_0, grammarAccess.getPointAccess().getZDOUBLETerminalRuleCall_3_1_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getPointRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"z",
                    							lv_z_4_0,
                    							"org.eclipse.gef.dot.internal.language.DotPoint.DOUBLE");
                    					

                    }


                    }


                    }
                    break;

            }

            // InternalDotPointParser.g:136:3: ( (lv_inputOnly_5_0= ExclamationMark ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==ExclamationMark) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDotPointParser.g:137:4: (lv_inputOnly_5_0= ExclamationMark )
                    {
                    // InternalDotPointParser.g:137:4: (lv_inputOnly_5_0= ExclamationMark )
                    // InternalDotPointParser.g:138:5: lv_inputOnly_5_0= ExclamationMark
                    {
                    lv_inputOnly_5_0=(Token)match(input,ExclamationMark,FOLLOW_2); 

                    					newLeafNode(lv_inputOnly_5_0, grammarAccess.getPointAccess().getInputOnlyExclamationMarkKeyword_4_0());
                    				

                    					if (current==null) {
                    						current = createModelElement(grammarAccess.getPointRule());
                    					}
                    					setWithLastConsumed(current, "inputOnly", lv_inputOnly_5_0 != null, "!");
                    				

                    }


                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePoint"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000032L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000012L});

}